commit 977043d8857fc931742542d329d513104e2b8cbd
Author: freddy77 <freddy77>
Date:   Sat Apr 10 14:29:36 2010 +0000

    add TDS_LIKELY/TDS_UNLIKELY macro and use them for logging

diff --git a/ChangeLog b/ChangeLog
index 1ca80b8..0281c23 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Sat Apr 10 16:29:29 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tds.h src/tds/log.c:
+	- add TDS_LIKELY/TDS_UNLIKELY macro and use them for logging
+
 Sat Apr 10 16:21:49 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tds.h src/tds/log.c:
 	- make execution faster if log disabled (patch from Steve Brown)
@@ -2392,4 +2396,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3008 2010/04/10 14:22:09 freddy77 Exp $
+$Id: ChangeLog,v 1.3009 2010/04/10 14:29:36 freddy77 Exp $
diff --git a/include/tds.h b/include/tds.h
index 08580ee..930e60a 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -21,7 +21,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.334 2010/04/10 14:22:09 freddy77 Exp $ */
+/* $Id: tds.h,v 1.335 2010/04/10 14:29:36 freddy77 Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -682,6 +682,14 @@ typedef enum tds_encryption_level {
 #define TDS_ZERO_FREE(x) do {free((x)); (x) = NULL;} while(0)
 #define TDS_VECTOR_SIZE(x) (sizeof(x)/sizeof(x[0]))
 
+#if defined(__GNUC__) && __GNUC__ >= 3
+# define TDS_LIKELY(x)	__builtin_expect(!!(x), 1)
+# define TDS_UNLIKELY(x)	__builtin_expect(!!(x), 0)
+#else
+# define TDS_LIKELY(x)	(x)
+# define TDS_UNLIKELY(x)	(x)
+#endif
+
 /*
  * TODO use system macros for optimization
  * See mcrypt for reference and linux kernel source for optimization
@@ -1587,7 +1595,7 @@ void tdsdump_log(const char* file, unsigned int level_line, const char *fmt, ...
 	__attribute__ ((__format__ (__printf__, 3, 4)))
 #endif
 ;
-#define tdsdump_log if (tds_write_dump) tdsdump_log
+#define tdsdump_log if (TDS_UNLIKELY(tds_write_dump)) tdsdump_log
 
 extern int tds_write_dump;
 extern int tds_debug_flags;
diff --git a/src/tds/log.c b/src/tds/log.c
index 3d51bcd..afc8f1b 100644
--- a/src/tds/log.c
+++ b/src/tds/log.c
@@ -66,7 +66,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: log.c,v 1.18 2010/04/10 14:22:09 freddy77 Exp $");
+TDS_RCSID(var, "$Id: log.c,v 1.19 2010/04/10 14:29:36 freddy77 Exp $");
 
 /* for now all messages go to the log */
 int tds_debug_flags = TDS_DBGFLAG_ALL | TDS_DBGFLAG_SOURCE;
@@ -420,7 +420,7 @@ tdsdump_log(const char* file, unsigned int level_line, const char *fmt, ...)
 #endif
 	TDS_MUTEX_UNLOCK(&g_dump_mutex);
 }				/* tdsdump_log()  */
-#define tdsdump_log if (tds_write_dump) tdsdump_log
+#define tdsdump_log if (TDS_UNLIKELY(tds_write_dump)) tdsdump_log
 
 
 /**

